# -*- coding: utf-8 -*-
"""
Created on Mon Nov 28 15:37:53 2011 @author: tengen
Wasserbewegung in der Bodenzone
"""
from numpy import *
from fit_changed import *
import guiqwt.pyplot as plt 

################################################################################
##Input
in_n_18o='O18_N_alpha_Freiburg.txt'
in_dat_p=loadtxt(in_n_18o)     ##O,N,alpha
'''Daten Beginn:15.06.98, Ende:15.07.10, Monatswerte (15....)'''

in_month=size(in_dat_p[:,0])
soil_w_monat=in_dat_p[:,1]*in_dat_p[:,2]
mittel_in=sum((in_dat_p[:,0]*soil_w_monat))/sum(soil_w_monat)

print sum(soil_w_monat)*12/in_month
print mittel_in, mean(in_dat_p[:,0])
print in_month

a=(max(in_dat_p[in_month-13:in_month,0])-min(in_dat_p[in_month-13:in_month,0]))/2
xoo=mittel_in

##Zeitpunkt / Monat Probehahme
profil_dat=07 ##10

x0=in_dat_p[in_month-1,0]

################################################################################
##Goodness of fit (Hornberger et al. 1992)
def good_fit(Cf,Cobs):
    Cmean=mean(Cobs)
    return 1-(sum((Cf-Cobs)**2)/sum((Cf-Cmean)**2))
##Delta Input aus Datei 
def c_in_p(monat):
    t=in_month-(monat+1)
    p=(in_month-(monat+1)>=0).nonzero()
    p= p[0]
    out=zeros((size(y),2),float)
    out[0:size(p),0]=in_dat_p[t[0:size(p)],0]
    out[size(p):size(y),0]=mittel_in

    return out[:,0]

#    t=in_month-(monat+1)
#    if monat > size(in_dat_p[:,0]):
#        return mittel_in
#    else:
#        return in_dat_p[t,0]
#    
##Anpassung einer Daempfung und Sickergeschwindigkeit an Inputwerte
def c_boden(z,params):
    
    v,d,xoo,din=params
    
    monat=-z/(v/12.)+0.5+t_t
    monat=monat.astype(int)
        
    c_in=c_in_p(monat)

    damp=e**(z/d)

    return c_in*damp+xoo*(1-damp)+din # c_in_p(monat)*e**(-z/d)

def v_damp_fit(z,y,t_t):   
    
    v = FitParam("Sickergeschwidigkeit (cm/a)", 100., 1., 500.)
    d = FitParam("Daempfung (cm)", 100., 0., 500.)       
    xoo = FitParam("Endwert (cm)", mittel_in, -15., 5.) 
    din = FitParam("Versatz", 0, -5., 5.)
     
    params = [v,d,xoo,din]
        
    values = guifit(z, y, c_boden, params, xlabel="Tiefe (cm)", ylabel="Isotop")

#    print values
    ##root-mean-square error /normalized
    rmse=(sum((c_boden(z,values)-y)**2)/size(y))**0.5
    n_rmse=rmse/(max(y)-min(y))    
    print rmse
    return values,rmse,n_rmse


def min_quadr(z,y,n,m,step):

    res_quad=zeros((n/step,m/step),float)
    
    print mittel_in-mean(y[size(y)-3:size(y)])
   
    for v in range(step,n+1,step):            ##v
        monat=-z/(v/12.)+0.5+t_t
        monat=monat.astype(int)
        c_in=c_in_p(monat)
    
        for d in range(step,m+1,step):        ##d
        
            for xoo in range(int(100*mittel_in),int(100*mean(y[size(y)-3:size(y)])),50):     ##xoo
               xoo=xoo/100. 
               
               c_boden=zeros((size(y)),float)
               
               for l in range(0, size(y)):             
                   if int(round((-z[l]/(v/12.)))) > in_month:
                       c_boden[l]=mittel_in
                   else:
#                       c_boden[l]=c_in_p(int(round((-z[l]/(v/12.)))))*e**(z[l]/d)+xoo*(1-e**(z[l]/d)) 
                       c_boden[l]=c_in[l]*e**(z[l]/d)+xoo*(1-e**(z[l]/d))
               
               res_quad[v/step-1,d/step-1]=(sum((c_boden-y)**2)/size(y))**0.5
   
    x_min,y_min=int(res_quad.argmin()/(m/step)),res_quad.argmin()-(n/step)*int(res_quad.argmin()/(m/step))
    
    print x_min,y_min, res_quad.argmin(),xoo
    min_val=res_quad[x_min,y_min]  
    print min_val 
    print 'v:',((x_min+1)*step),'d:',((y_min+1)*step),'xoo:',xoo
    return ((x_min+1)*step),((y_min+1)*step),xoo,min_val
    
################################################################################

in_data='jakob.txt'
#in_data='test\in_data\kaiserstuhl_1.txt'
in_dat=loadtxt(in_data)

z,y=in_dat[:,0],in_dat[:,1]
t_t=12.

SHOW = True    
a=v_damp_fit(z,y,t_t)
values=a[0]
model=c_boden(z,values)
print 'Sickergeschwindigkeit:',values[1],'cm pro Jahr'
print 'Daempfung:', values[0],'[1/cm]'
print 'Qualitaet der Modellierung (Root Mean Square Error):',a[1]
print 'Qualitaet der Modellierung (Normalized Root Mean Square Error):',a[2]
print 'Goodness of fit:',good_fit(model,y)
print'###############################'

plt.plot(y,z,'b--',label='Data')
plt.plot(model,z,'r-',label='ModelData')
plt.legend()
plt.show()

################################################################################
n,m,step=400,400,5
b=min_quadr(z,y,n,m,step)
print b[0]
print 'Sickergeschwindigkeit:',b[0],'cm pro Jahr'
print 'Daempfung:', b[1],'[1/cm]'
print 'Qualitaet der Modellierung (Root Mean Square Error):',b[3]
values_b=[b[0],b[1], b[2]]
print values_b

plt.plot(y,z,'b--')
plt.plot(c_boden(z,values),z,'r-')
plt.plot(c_boden(z,values_b),z,'b-')
plt.show()

print 'end'







