# -*- coding: utf-8 -*-
"""
Created on Mon Nov 28 15:37:53 2011 @author: tengen
Wasserbewegung in der Bodenzone
"""
from numpy import *
from fit_changed import *
from guiqwt.widgets.fit import FitParam, guifit
import guiqwt.pyplot as plt 

################################################################################
##gedaempfte Schwingung: a-Amplitude, x0-Anfagngswert, xoo, "Endwert", f-Frequenz (Tiefe), 
##po-Anfangsphase (Isotopenwert), d-Daempfung, t-Tiefe(NEGATIVE WERTE!!!)
def sin_dam(z, params):
    a, d, f, x0,xoo,v_f = params
    po=arcsin((x0-xoo)/a)
    f_z=f*e**(-z/v_f)
    return a*e**(z/d)*sin(2*pi*z/f_z+po)+xoo
##Anpassung einer gedämpften Sinuskurve
def sin_fit(t,y):

    a = FitParam("Amplitude", 4., -65., 65.)
    f = FitParam("Frequency", 100., 0., 400.)
    d = FitParam("Daempfung", 100., 0., 400.)  
    x0 = FitParam("Isotop(t=0)", -5., -100., 5.)
    xoo = FitParam("Offset", -5., -100., 10.)
    v_f = FitParam("Geschwindigkeitsdaempfung", 200., 50., 1000.)
    
    params = [a,d,f,x0,xoo,v_f]
    values = guifit(z, y, sin_dam, params, xlabel="Tiefe (cm)", ylabel="Isotop")
    
    ##root-mean-square error /normalized
    rmse=(sum((sin_dam(z,values)-y)**2)/size(y))**0.5
    n_rmse=rmse/(max(y)-min(y))    

    return values,rmse,n_rmse
################################################################################

in_data='jakob.txt'

in_dat=loadtxt(in_data)

z,y=in_dat[:,0],in_dat[:,1]

SHOW = True    
a=sin_fit(z,y)
values=a[0]
print 'v:',values[2],'cm pro Jahr'
print 'Qualitaet der Modellierung (Root Mean Square Error):',a[1]
print 'Qualitaet der Modellierung (Normalized Root Mean Square Error):',a[2]
print values

#print sin_dat
plt.plot(y,z,'b--')
plt.plot(sin_dam(z,values),z,'r-')
plt.show()
print 'end'







