# -*- coding: utf-8 -*-
"""
Created on Mon Feb 20 11:53:10 2012 @author: tengen
"""
#Main: Aufrufen der Module

from numpy import *
import guiqwt.pyplot as plt 
from os import chdir as chdir
from atm_in import *
import boden_bewegung as b_bw

#Lösungsmatrix: Anzahl- Tiefe, Prameter, Zeit
"""
    |------- t
 z0 |      |  
    |      |  Parameter (Wassergehalt,Potential,,unsat k, k',Pot',Pot'',Fluss)
 zn |      |
    |------|
"""

z_n,para_n,t_n=10,6+1,100     
soil_m=zeros((z_n,t_n+1),float)

tiefe=size(soil_m[:,0])
print 'z',tiefe, 't',size(soil_m[:,0])
h=5.             #bodenschichtendicke
hour,day,month=1./24.,1.,30.
dt=hour                               #umrechnung der mm/d in mm/auswahl
boden_e_vol=h*b_bw.genu_para[0,1]     #boden_schicht_tiefe*nutzbare porosität ->mm
print boden_e_vol

##Bodenarten
boden_schicht_1='Sl2'
BS_1=boden_schicht_1
boden_1_maechtig=35
M1=int(boden_1_maechtig/h)
boden_schicht_2='Ut4'
BS_2=boden_schicht_2
boden_2_maechtig=50
M2=int(boden_2_maechtig/h)

##Randbedinungen k-berechnungsmethode
W0=0.35
W00=0.35
stauer=1            ##0,1   kein Stauer-0, Stauer-1
k_calc_method=3     #methoden um k zu bestimmen(0,1-2-3-4)

##Atmosphaere
a=atm_input()
#print a.in_all(sample_date,lat)[0,:]
#print a.in_all(sample_date,lat+25)[0,:]

N=[1,2,2,0,0,0,0,0,0,0,0,0,0,0,0,0]

##Bodenart und nutzbare porosität
genu_soil,genu_para=b_bw.genu_soil,b_bw.genu_para

soil_class=['']*tiefe
soil_class[0]='atmo'

n=zeros(tiefe,float)

for s in range(1,M1):
    soil_class[s]=BS_1
    n[s]=b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[1]

for s in range(M1,M2):
    soil_class[s]=BS_2
    n[s]=b_bw.soil_genu_parameter(boden_schicht_2,genu_soil,genu_para)[1]

print soil_class
print''
################################################################################

#wasser
soil_m[0,0]=N[0]             #oberhalb Boden: Saettigung (check position soil abh.)
soil_m[1:,0]=0.35                             #Anfangswerte setzen
soil_m[5,0]=0.17
#soil_m[tiefe-1,0]=soil_m[tiefe-2,0]   
#soil_m[tiefe-1,0]=W00                         #undurchlaessi

 #Potential mit Schichten
def Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,Wa):
    Po=zeros(tiefe,float)
    Po[1:M1]=b_bw.potential(BS_1,genu_soil,genu_para,Wa[1:M1])   #hPa (=-cm)
    Po[M1:M2]=b_bw.potential(BS_2,genu_soil,genu_para,Wa[M1:M2])   #hPa (=-cm)
    #Rand
    Po[0]=Wa[0] #Po[1]
    Po[tiefe-1]=Po[M2-1]
    
    niederschlag=1
    if niederschlag == 0:
        Po[0]=pot_verd     #hPa (=-cm)
    return Po

#leitfaehigkeit mit Schichten
def ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,Pot):
    ko=zeros(tiefe,float)
    ko[1:M1]=b_bw.unsat_k_pot(BS_1,genu_soil,genu_para,Pot[1:M1])   #cm/d
    ko[M1:M2]=b_bw.unsat_k_pot(BS_2,genu_soil,genu_para,Pot[M1:M2]) 
    #Rand
    ko[0]=ko[1]
    ko[tiefe-1]=ko[M2-1]
    
    ko=ko*dt                                        #umrechnung in cm/zeiteinheit
    return ko

P0=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,soil_m[:,0])  
k0=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,P0)

#Po'
P_diff_0=zeros(tiefe,float)
#!!!!!!!!!!!!!!!!!!!!!#
P_diff_0[0]=N[0]
#!!!!!!!!!!!!!!!!!!!!!#
P_diff_0[1:]=(P0[1:]-P0[:tiefe-1])/h      ##???? h*n ???? ####

print soil_m[:,0]
print sum(soil_m[:,0])
print P_diff_0

#----------------------------------------

plt.plot(soil_m[:,0])
plt.show()


#for i in range(0,t_n):
for i in range(0,15):
    print i, 'I'
    print ''   
    
    if i > 0:
        #        W[0]=0#N[i]
        P=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,W)
        P[0]=N[i]
        k=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,P)
        
        W[0]=N[i]       
        #!!!!!!!!!!!!!!!!!!!!!#
        P_diff[0]=W[0]
        #!!!!!!!!!!!!!!!!!!!!!#
        P_diff[1:]=(P[1:]-P[:tiefe-1])/h

        tau=1
        
        soil_m[:,i]=W
        F=k*(P_diff-1)*1/(h*n)        ##als anteil wasser ausgedrueckt
    
    else:
        W=zeros(tiefe,float)        
        W[:]=soil_m[:,i]
        W_k_calc=zeros(tiefe,float)
        k_calc=zeros(tiefe,float)
        F_delta=zeros(tiefe,float)
        P=P0
        P[0]=N[i]

        k=k0
        P_diff=P_diff_0
        #initialfluss 
        F=k0*(P_diff-1)*1/(h*n)     ##als anteil wasser ausgedrueckt
    
    
    sum_tau=0
    tau=1.          ### 1 Zeiteinheit (nach Wahl)
    
    print W,P,P_diff
    plt.plot(W)
    plt.show()

    #Bestimmung Fluss (cm/d) + variabler zeitschritt dt
    while sum_tau < 1:
        ###oberste schicht - luft beruecksichtigen!!!!!!!!!!!!!! 
        #fliessrichtung 
        down, down_grav, up = where(P_diff < 0)[0], where(P_diff == 0)[0] , where(P_diff > 0)[0]

        ########################k_calc
        if k_calc_method <= 1:
            #Wassergehalt zur k bestimmung
            anteil=0.5
            if anteil <> 0.5:            
                W_k_calc[down] = W[down-1]-anteil*(W[down-1]-W[down])/2
                W_k_calc[down_grav]=W[down_grav]
                if max(up) >= size(W)-1:
                    W_k_calc[up[:size(up)-1]]=W[up[:size(up)-1]]-anteil*(W[up[:size(up)-1]]-W[up[:size(up)-1]-1])/2
                else:
                    W_k_calc[up]=W[up]-anteil*(W[up]-W[up+1])/2
            else:
                W_k_calc[1:]=(W[1:]+W[:size(W)-1])/2
            
            W_k_calc[0]=W_k_calc[1]
            #k bestimmung
            P_k_calc=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,W_k_calc) 
            k_calc=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,P_k_calc)

        
        elif k_calc_method == 2:
            ##mittelwert
            k_calc[1:]= (k[1:]+k[:tiefe-1])/2
            k_calc[0]=k_calc[1]
            
        elif k_calc_method == 3:
            ##geometrisches mittel
            k_calc[1:]= (k[1:]*k[:tiefe-1])**0.5
            k_calc[0]=k_calc[1]
        
        ##Uebergang in andren horizont
        k_calc[M1]=min(k_calc[M1], k_calc[M1-1])

#        stauer=1
        if stauer == 1:             #undurchlassig/stauer
            k_calc[tiefe-1]=0
        #########################################
        
        #fluss mit groesseren k von beiden zellen        
        
        F=(k_calc*(P_diff-1.)*tau)/(h*n)
        if stauer == 1:
            F[tiefe-1] = 0
            
        ########################################################################
        #Flussregulation zelle darf nicht nachbarzelle uebersteign 
        #Delta Wasser - Differenzen der Wassergehalte (kleinere der beiden nachbarzellen)
        D_W_oben=zeros(size(W),float)
        D_W_oben[1:]= absolute(W[:size(W)-1]-W[1:])

        D_W_unten=zeros(size(W),float)
        D_W_unten[1:size(W)-1]= absolute(W[2:]-W[1:size(W)-1])

        unten=where(D_W_unten < D_W_oben)
        oben=where(D_W_unten > D_W_oben)
        D_W=D_W_unten
        D_W[oben]=D_W_oben[oben]
        
        #kleine wasserdifferenzen ignorieren
        D_W[where(D_W < 0.0001)]=10
        if sum(D_W)==tiefe*10:
            t_min=tau
        else:
#            D_tau=(h*n[1:])*absolute(D_W[1:]/(2*(k_calc[:tiefe-1]*(P_diff[:tiefe-1]-1)-k_calc[1:]*(P_diff[1:]-1))))
            D_tau=(h*n[1:tiefe-1])*absolute(D_W[1:tiefe-1]/(2*(k_calc[1:tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))))
            D_tau[where(k_calc[1::tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))==0]=1
            
            if stauer == 1:
                D_tau=(h*n[1:tiefe-1])*absolute(D_W[1:tiefe-1]/(2*(k_calc[1:tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))))
                D_tau[where(k_calc[1::tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))==0] = 1
#            D_tau[where(k_calc[:tiefe-1]*(P_diff[:tiefe-1]-1)-k_calc[1:]*(P_diff[1:]-1) == 0)]=1
            
            t_01_down=(h*n[1:tiefe-1])*absolute(  0.1  *n[1:tiefe-1]/((k_calc[1:tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))))
            
            t_min=min(min(D_tau[:]),min(t_01_down))
        
        if W[0] > 0:
            print t_min
            print W[0]*(h*n[1]),W[0]*(n[1]), W[0]*(h*n[1])/(k_calc[1]*P_diff[1])
            t_min=min(h*n[1]*absolute(W[0]/(k_calc[1]*P_diff[1])), t_min)
            print 'hier', t_min
            print fafa
        print '........'
        print t_min, 't_min'
        
        
        F=(k_calc*(P_diff-1.)*t_min)/(h*n)

        
        if t_min > 0.01/dt or t_min*0 <> 0 :
                        
#            if t_min > 1.:
#                t_min=1.
            if t_min*0 <> 0:
                t_min=0.05
            if t_min >0.5:
                t_min=0.05#t_min/2

                    

            pos_t=where(D_tau[:]==t_min)[0]+1
            print pos_t, t_min,0.01/dt
            
#            print 'DW', D_W

#            t_min=0.01/dt


################################################################################
        ##Bedingung: beachtung der variablen geschwindigkeit des flusses (dt wird verkleinert)
        inter_tau=0
        if t_min > dt*1001:
#            
            print 'ok', tau, tau*0.1,t_min        
#        
#            print'....----.....'
#            #groesster initial Fluss, ma zelle mit groestem input, mi zelle mit groesstem output
#            ma=max(-F[1:tiefe-1]+F[2:])
#            mi=min(-F[1:tiefe-1]+F[2:])
#            #position des max fluss
#            ma_po=where((-F[1:tiefe-1]+F[2:]) == ma)[0]+1
#            print F
#            mi_po=where((-F[1:tiefe-1]+F[2:]) == mi)[0]+1
#            print t_min, ma, ma_po, mi_po
#            #infiltr. oberflaechenwasser ist max
#            if ma_po ==1 and mi_po <> 2:
#                mi_po=0
#            #Richtung und Position
#            #?? gibt es die situation, dass max i und max out nicht beieinander sind?
#        
#            #spaetester ausgleichswert-wassergehalt
#            up_down_pos= -1     #  Abwaerts
#            if (-F[ma_po]) < (-F[ma_po+1]):         #(hochwaerts)
#                up_down_pos= 1
#            print up_down_pos
#            #ausgleichswassergehalt zwischen den zellen  
#            Q_mitte=(W[ma_po+up_down_pos]+W[ma_po])/2.
#       
#            del_Q=(W[ma_po+up_down_pos]-Q_mitte)     #wie oben als wassergehalt ausgedrueckt 
# 
#            #Wassergehalt fuer k berechnung
#            intervalle=[0.1,0.2,0.3,0.4]
#            anteil=[0.05,0.2,0.45,0.8]  #(1-(1*sum(bisher)+intrevall[*]*0.5))
#            anteil_delta_Q = W[ma_po+up_down_pos] - del_Q * anteil
##            print del_Q ,sum(del_Q * intervalle), anteil_delta_Q
#                     
#            for new_t in range(0,size(intervalle)):
#
#                print 'schleife',new_t, t_min
#                if new_t > 0:
#                    #fliessrichtung 
#                    P=b_bw.potential(soil,genu_soil,genu_para,W)
#                    P_diff[0]=P0
#                    P_diff[1:]=(P[1:]-P[:tiefe-1])/h
#                    down, down_grav, up = where(P_diff < 0)[0], where(P_diff == 0)[0] , where(P_diff > 0)[0]
#                
#                ##mittlerer k wert fuer zeitabschnitt, vielleicht besser 75% wert oder 2/3 oder geometrisches mittel
#                k_tau=b_bw.unsat_k_pot(soil,genu_soil,genu_para,anteil_delta_Q[new_t])*dt 
#              
#                #benoetigte zeit
#                tau=absolute((-del_Q*intervalle[new_t])*h/(k_tau*(P_diff[ma_po]-1)))
#                                    
#                #Wassergehalt zur k bestimmung                
#                W_k_calc[down] = W[down-1]-anteil[new_t]*(W[down-1]-W[down])/2
#                W_k_calc[down_grav]=W[down_grav]
#
#                if max(up) >= size(W)-1:
#                    W_k_calc[up[:size(up)-1]]=W[up[:size(up)-1]]-anteil[new_t]*(W[up[:size(up)-1]]-W[up[:size(up)-1]-1])/2
#                else:
#                    W_k_calc[up]=W[up]-anteil[new_t]*(W[up]-W[up+1])/2
#
#                #k bestimmung
#                k_calc=b_bw.unsat_k_pot(soil,genu_soil,genu_para,W_k_calc)*dt
#                #Fluss bestimmung
#                F_calc=k_calc*(P_diff-1)*tau/h          
#                
#                W[:size(W)-1]=W[:size(W)-1]-(F_calc[:size(W)-1]-F_calc[1:])
#                W[0]=W0
#                W[size(W)-1]=W00
#              
#              ##benoetigte zeit darf nihct dt ueberschreiten  
#                if (inter_tau+tau) > t_min:
#                    tau=t_min-inter_tau
#                    
#                    F_calc=k_calc*(P_diff-1)*tau/h          
#                    
#                    W[:size(W)-1]=W[:size(W)-1]-(F_calc[:size(W)-1]-F_calc[1:])
#                    W[0]=W0
#                    W[size(W)-1]=W00
#                    sum_tau=sum_tau+tau
#                    
#                    print 'sdsddsdsdsdsdsdsdsdsddsdsdsdsdsdsdsdds', tau
#
#                    break             
#
#                sum_tau=sum_tau+tau
#                inter_tau=inter_tau+tau
##########################################if-else################################

        else:
            if t_min < 1 and t_min >0:
                tau=t_min
                ##benoetigte zeit darf nicht dt ueberschreiten  
                if (sum_tau+tau) > 1:
                    tau=1-sum_tau                
                
#                print tau, 'tau', sum_tau, 'sumtau'
                F_calc=k_calc*(P_diff-1)*tau/(h*n)
                F_calc[0]=k_calc[0]*(P_diff[0]-1)*tau/(h*n[1])
                if F_calc[0] <0:
                    F_calc[0]=0
#                if F_calc[1] < 0 and F_calc[1]
                
                print F_calc
                print 'F-calc'

                if stauer == 1:               #undurchlassig/stauer
                    F_calc[tiefe-1]=0
                
                F_delta[:tiefe-1]=(F_calc[:tiefe-1]-F_calc[1:])
                
                
                ##saettigung                    
                voll= where(W[1:]-F_delta[1:] > n[1:])[0]+1
                
                while sum(voll)>0:
                    print voll#, sum(voll)
#                    print W,n[voll]
                    t_v=0
                    for v in (voll[::-1]):
#                        print v
#                        print F_delta[v], F_calc[v], F_calc[v+1]
                        
                        #von oben nicht von unten
                        if F_calc[v] < 0 and F_calc[v+1] == 0:

                            F_calc[v]=(W[v]-n[v])

                        #von oben und nach unten (hoffentlich kleiner nach unten)
                        elif F_calc[v] < 0 and F_calc[v+1] < 0:
                            F_calc[v]=(W[v]-n[v])-F_calc[v+1]   #F_calc[v+1] durch vorige Schritte vorgegeben
                        
                        #von oben und von unten
                        elif F_calc[v] < 0 and F_calc[v+1] > 0:
                            
                            print 'spezialfall ueberpruefen'
                            
                            tau_voll=absolute((W[v]-n[v])*tau/(F_calc[v]-F_calc[v+1]))
                            if tau_voll <= tau:
                                a=F_calc[v]
                                F_calc[v] = F_calc[v]*tau_voll/tau
                                F_calc[v+1] = F_calc[v+1]*tau_voll/tau 
                                b=F_calc[v]
             
 
                        ########################################################
                        #von unten nichts von oben
                        elif F_calc[v] == 0 and F_calc[v+1] > 0:
                            F_calc[v+1]=-(W[v]-n[v])
                            print 'hier oben'

                        #nach oben (hoffentlich kleiner nach unten) und von unten
                        elif F_calc[v] > 0 and F_calc[v+1] > 0:
                            F_calc[v+1]=-(W[v]-n[v])+F_calc[v]               

#                        print F_calc[v], 'neu_fcal'
#                        print tau_voll, tau, 'tau'
                        t_v=t_v+1

                    
                    if stauer == 1:               #undurchlassig/stauer
                         F_calc[tiefe-1]=0
                    
                    F_delta[:tiefe-1]=(F_calc[:tiefe-1]-F_calc[1:])

         
                    voll= (where((W-F_delta).round(6) > n.round(6))[0])
        
                ################################################################
#                if F_delta[0] >= 0:
#                    F_delta[0]=0
#                else:
#                F_delta[0]=F_delta[0]*(h*n[1])
                    
                print W
                W=W-F_delta
                


                sum_tau=sum_tau+tau

        print 'aaaaaaaahhhhhhhhhhhhhaaaaaaaaaa'
        
#        print F_delta

        print W
        print tau, sum_tau, 'sum-tau'
        print N[i], n[0]
        print F_delta

########################if-else#################################################
    print '-----------------------------------'
    print 'zeit:', sum_tau, i, dt, (1+i)*dt
    W=W.round(4)
    print W
    print sum(W)
    print N[i]

    plt.plot(W)
    plt.show()


plt.plot(W)
plt.show()
############################################while###############################
print 'unten',soil_m[:,i]
