# -*- coding: utf-8 -*-
"""
Created on Mon Feb 20 11:53:10 2012 @author: tengen
"""
#Main: Aufrufen der Module

from numpy import *
import guiqwt.pyplot as plt 
from os import chdir as chdir
from atm_in import *
import boden_bewegung as b_bw

#Lösungsmatrix: Anzahl- Tiefe, Prameter, Zeit
"""
    |------- t
 z0 |      |  
    |      |  Parameter (Wassergehalt,Potential,,unsat k, k',Pot',Pot'',Fluss)
 zn |      |
    |------|
"""

z_n,para_n,t_n=10,6+1,33     
soil_m=zeros((z_n,t_n+1),float)

tiefe=size(soil_m[:,0])
print 'z',tiefe, 't',size(soil_m[:,0])
h=5.             #bodenschichtendicke
hour,day,month=1./24.,1.,30.
dt=day                               #umrechnung der mm/d in mm/auswahl
boden_e_vol=h*b_bw.genu_para[0,1]     #boden_schicht_tiefe*nutzbare porosität ->mm
Verd=0                              ##Verdunstung als Summe
print boden_e_vol

##Bodenarten
boden_schicht_1='Sl2'
BS_1=boden_schicht_1
boden_1_maechtig=35
M1=int(boden_1_maechtig/h)
boden_schicht_2='Ut4'
BS_2=boden_schicht_2
boden_2_maechtig=50
M2=int(boden_2_maechtig/h)

##Randbedinungen k-berechnungsmethode
W0=0.35
W00=0.35
stauer=1            ##0,1   kein Stauer-0, Stauer-1
k_calc_method=3     #methoden um k zu bestimmen(0,1-2-3)

##Atmosphaere
a=atm_input()
atm_pot=-99450

#print a.in_all(sample_date,lat)[0,:]
#print a.in_all(sample_date,lat+25)[0,:]
#
#print faf

N=zeros(t_n+1,float)
##Bodenart und nutzbare porosität
genu_soil,genu_para=b_bw.genu_soil,b_bw.genu_para


soil_class=['']*tiefe
soil_class[0]='atmo'

n=zeros(tiefe,float)
n[0]=1
for s in range(1,M1):
    soil_class[s]=BS_1
    n[s]=b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[1]

for s in range(M1,M2):
    soil_class[s]=BS_2
    n[s]=b_bw.soil_genu_parameter(boden_schicht_2,genu_soil,genu_para)[1]

print soil_class
print''
################################################################################

#wasser
soil_m[0,0]=N[0]             #oberhalb Boden: Saettigung (check position soil abh.)
soil_m[1:,0]=0.35                             #Anfangswerte setzen
soil_m[5,0]=0.17
#soil_m[tiefe-1,0]=soil_m[tiefe-2,0]   
#soil_m[tiefe-1,0]=W00                         #undurchlaessi

 #Potential mit Schichten
def Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,Wa):
    Po=zeros(tiefe,float)
    Po[1:M1]=b_bw.potential(BS_1,genu_soil,genu_para,Wa[1:M1])   #hPa (=-cm)
    Po[M1:M2]=b_bw.potential(BS_2,genu_soil,genu_para,Wa[M1:M2])   #hPa (=-cm)
    #Rand
    Po[0]=Wa[0] #Po[1]
    Po[tiefe-1]=Po[M2-1]
    
    niederschlag=1
    if niederschlag == 0:
        Po[0]=pot_verd     #hPa (=-cm)
    return Po

#leitfaehigkeit mit Schichten
def ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,Pot):
    ko=zeros(tiefe,float)
    ko[1:M1]=b_bw.unsat_k_pot(BS_1,genu_soil,genu_para,Pot[1:M1])   #cm/d
    ko[M1:M2]=b_bw.unsat_k_pot(BS_2,genu_soil,genu_para,Pot[M1:M2]) 
    #Rand
    ko[0]=ko[1]
    ko[tiefe-1]=ko[M2-1]
    
    ko=ko*dt                                        #umrechnung in cm/zeiteinheit
    return ko

P0=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,soil_m[:,0])  
k0=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,P0)

#Po'
P_diff_0=zeros(tiefe,float)
#!!!!!!!!!!!!!!!!!!!!!#
P_diff_0[0]=N[0]
#!!!!!!!!!!!!!!!!!!!!!#
P_diff_0[1:]=(P0[1:]-P0[:tiefe-1])/h      ##???? h*n ???? ####

print soil_m[:,0]
print sum(soil_m[:,0])
print P_diff_0

#----------------------------------------

plt.plot(soil_m[:,0])
plt.show()


#for i in range(0,t_n):
for i in range(0,t_n):
    print i, 'I'
    print ''   
    
    if i > 0:
        #        W[0]=0#N[i]
        P=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,W)
        P[0]=N[i]
        if N[i] == 0:
            P[0]= atm_pot       ##atm verdunstung einsetzen
        k=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,P)
        
        W[0]=N[i]       
        #!!!!!!!!!!!!!!!!!!!!!#
        P_diff[0]=W[0]
        #!!!!!!!!!!!!!!!!!!!!!#
        P_diff[1:]=(P[1:]-P[:tiefe-1])/h

        tau=1
        
        soil_m[:,i]=W
        F=k*(P_diff-1)*1/(h)        ##als anteil wasser ausgedrueckt
    
    else:
        W=zeros(tiefe,float)        
        W[:]=soil_m[:,i]
        W_k_calc=zeros(tiefe,float)
        k_calc=zeros(tiefe,float)
        F_delta=zeros(tiefe,float)
        P=P0
        P[0]=N[i]
        if N[i] == 0:
            P[0]= atm_pot      ##atm verdunstung einsetzen

        k=k0
        P_diff=P_diff_0
        #initialfluss 
        F=k0*(P_diff-1)*1/(h)     ##als anteil wasser ausgedrueckt
    
    
    sum_tau=0
    tau=1.          ### 1 Zeiteinheit (nach Wahl)
    

    #Bestimmung Fluss (cm/d) + variabler zeitschritt dt
    while sum_tau < 1:
        ###oberste schicht - luft beruecksichtigen!!!!!!!!!!!!!! 
   #############################################################################     
        #fliessrichtung 
        down, down_grav, up = where(P_diff < 0)[0], where(P_diff == 0)[0] , where(P_diff > 0)[0]

        ########################k_calc
        if k_calc_method <= 1:
            #Wassergehalt zur k bestimmung
            anteil=0.5
            if anteil <> 0.5:            
                W_k_calc[down] = W[down-1]-anteil*(W[down-1]-W[down])/2
                W_k_calc[down_grav]=W[down_grav]
                if max(up) >= size(W)-1:
                    W_k_calc[up[:size(up)-1]]=W[up[:size(up)-1]]-anteil*(W[up[:size(up)-1]]-W[up[:size(up)-1]-1])/2
                else:
                    W_k_calc[up]=W[up]-anteil*(W[up]-W[up+1])/2
            else:
                W_k_calc[1:]=(W[1:]+W[:size(W)-1])/2
            
            W_k_calc[0]=W_k_calc[1]
            #k bestimmung
            P_k_calc=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,W_k_calc) 
            k_calc=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,P_k_calc)
            #check k_calc[0]
        
        elif k_calc_method == 2:
            ##mittelwert
            k_calc[1:]= (k[1:]+k[:tiefe-1])/2
            k_calc[0]=k_calc[1]
            
        elif k_calc_method == 3:
            ##geometrisches mittel
            k_calc[1:]= (k[1:]*k[:tiefe-1])**0.5
            k_calc[0]=k_calc[1]
        
        ##Uebergang in andren horizont
        k_calc[M1]=min(k_calc[M1], k_calc[M1-1])

#        stauer=1
        if stauer == 1:             #undurchlassig/stauer
            k_calc[tiefe-1]=0

   #############################################################################                
        
            
        ########################################################################
        #Flussregulation zelle darf nicht nachbarzelle uebersteign 
        #Delta Wasser - Differenzen der Wassergehalte (kleinere der beiden nachbarzellen)
        D_W_oben=zeros(size(W),float)
        D_W_oben[1:]= absolute(W[:size(W)-1]-W[1:])

        D_W_unten=zeros(size(W),float)
        D_W_unten[1:size(W)-1]= absolute(W[2:]-W[1:size(W)-1])

        unten=where(D_W_unten < D_W_oben)
        oben=where(D_W_unten > D_W_oben)
        D_W=D_W_unten
        D_W[oben]=D_W_oben[oben]
        
        #kleine wasserdifferenzen ignorieren
        D_W[where(D_W < 0.0001)]=10
        if sum(D_W)==tiefe*10:
            t_min=1
        else:
#            D_tau=(h*n[1:])*absolute(D_W[1:]/(2*(k_calc[:tiefe-1]*(P_diff[:tiefe-1]-1)-k_calc[1:]*(P_diff[1:]-1))))
            D_tau=h*absolute(D_W[1:tiefe-1]/(2*(k_calc[1:tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))))
            D_tau[where(k_calc[1::tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))==0]=1
            
            if stauer == 1:
                D_tau=h*absolute(D_W[1:tiefe-1]/(2*(k_calc[1:tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))))
                D_tau[where(k_calc[1::tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))==0] = 1
#            D_tau[where(k_calc[:tiefe-1]*(P_diff[:tiefe-1]-1)-k_calc[1:]*(P_diff[1:]-1) == 0)]=1
            
            t_01_down=h*absolute(  0.1  *n[1:tiefe-1]/((k_calc[1:tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))))
            
            t_min=min(min(D_tau[:]),min(t_01_down))
        ##darf max das oberflaechenwasser infiltrieren 
        if W[0] > 0:
            t_min=min(h*absolute(W[0]/(k_calc[1]*(P_diff[1]-1))), t_min)
        
        ##Reduzierung der Zeit fuer die Verdunstung
        if W[0] == 0:
            t_min=min(h*absolute(n[1] * 0.1 /(k_calc[1]*(P_diff[1]-1))), t_min)

          
#        print '........'
#        print t_min, 't_min'
    
        if t_min > 0.01/dt or t_min*0 <> 0 :
                        
            if t_min*0 <> 0:
                t_min=0.05
            if t_min >0.5:
                t_min=0.05

                    

#            pos_t=where(D_tau[:]==t_min)[0]+1
#            print pos_t, t_min,0.01/dt



################################################################################
        ##Bedingung: beachtung der variablen geschwindigkeit des flusses (dt wird verkleinert)

##########################################if-else################################
        
        if t_min == 0:
            if dt==hour:
                t_min=0.24
            if dt==day:
                t_min=0.01
            if dt==month:
                t_min=0.00033

        if t_min < 1 and t_min >0:
            
            tau=t_min
            ##benoetigte zeit darf nicht dt ueberschreiten  
            if (sum_tau+tau) > 1:
                tau=1-sum_tau                
            
            ##fliessende wasseranteile
            F_calc=k_calc*(P_diff-1)*tau/(h)
            
            if W[0] >0:
                F_calc[0]=0
            elif F_calc[1] < 0:
                F_calc[1] = 0

#            print F_calc
#            print 'F-calc'

            if stauer == 1:               #undurchlassig/stauer
                F_calc[tiefe-1]=0
            
            F_delta[:tiefe-1]=(F_calc[:tiefe-1]-F_calc[1:])
            
            
            ##saettigung                    
            voll= where(W[1:]-F_delta[1:] > n[1:])[0]+1
            
            while sum(voll)>0:
                print 'voll',voll#, sum(voll)

                for v in (voll[::-1]):
                    
                    #von oben nicht von unten
                    if F_calc[v] < 0 and F_calc[v+1] == 0:

                        F_calc[v]=(W[v]-n[v])

                    #von oben und nach unten (hoffentlich kleiner nach unten)
                    elif F_calc[v] < 0 and F_calc[v+1] < 0:
                        F_calc[v]=(W[v]-n[v])+F_calc[v+1]   #F_calc[v+1] durch vorige Schritte vorgegeben
                    
                    #von oben und von unten
                    elif F_calc[v] < 0 and F_calc[v+1] > 0:
                        
#                        print 'spezialfall ueberpruefen'
                        F_calc[v]= F_calc[v]*(W[v]-n[v])/(F_calc[v]-F_calc[v+1])
                        F_calc[v+1]= F_calc[v+1]*(W[v]-n[v])/(F_calc[v]-F_calc[v+1])         
 
                    ########################################################
                    #von unten, nichts von oben
                    elif F_calc[v] == 0 and F_calc[v+1] > 0:
                        F_calc[v+1]=-(W[v]-n[v])
                        
#                        print 'hier oben'

                    #nach oben (hoffentlich kleiner nach unten) und von unten
                    elif F_calc[v] > 0 and F_calc[v+1] > 0:
                        F_calc[v+1]=-(W[v]-n[v])+F_calc[v]
                        print gg
                    
                    
                if stauer == 1:               #undurchlassig/stauer
                     F_calc[tiefe-1]=0
                
                F_delta[:tiefe-1]=(F_calc[:tiefe-1]-F_calc[1:])

     
                voll= (where((W-F_delta).round(6) > n.round(6))[0])
    
            ################################################################
            

            W=W-F_delta
            if N[i] == 0:
                Verd=Verd+W[0]
                W[0]=0
                
            P=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,W)

            P[0]=W[0]
            if W[0] <= 0:
                P[0]= atm_pot       ##atm verdunstung einsetzen]
            

            k=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m,P)
     
            #!!!!!!!!!!!!!!!!!!!!!#
            P_diff[0]=W[0]
            #!!!!!!!!!!!!!!!!!!!!!#
            P_diff[1:]=(P[1:]-P[:tiefe-1])/h
                
            sum_tau=sum_tau+tau

########################if-else#################################################
    print '-----------------------------------'
    print 'zeit:', sum_tau, i, dt, (1+i)*dt
#    W=W.round(4)
    print W
    print sum(W), 'sum W'
    print Verd, 'Verdunstung'
    print N[i]

#    plt.plot(W)
#    plt.show()
    
    soil_m[:,i+1]=W                             #Anfangswerte setzen



plt.plot(W)
plt.show()
############################################while###############################
print P
print k
print P_diff
print ''
print 'unten',soil_m[:,i+1]
plt.plot(soil_m[:,0:t_n])
plt.show()
