# -*- coding: utf-8 -*-
"""
Created on Mon Feb 20 11:53:10 2012 @author: tengen
"""
#Main: Aufrufen der Module

from numpy import *
import guiqwt.pyplot as plt 
from os import chdir as chdir
from atm_in import *
import boden_bewegung as b_bw

#Lösungsmatrix: Anzahl- Tiefe, Prameter, Zeit
"""
    |------- t
 z0 |   /  |  /
    |  /   | /  Parameter (Wassergehalt,Potential,,unsat k, k',Pot',Pot'',Fluss)
 zn | /    |/
    |------|
"""

z_n,para_n,t_n=10,6+1,100     
soil_m=zeros((z_n,para_n,t_n+1),float)

tiefe=size(soil_m[:,0,0])
h=5.             #bodenschichtendicke
hour,day,month=1./24.,1.,30.
dt=day                               #umrechnung der mm/d in mm/auswahl
boden_e_vol=h*b_bw.genu_para[0,1]     #boden_schicht_tiefe*nutzbare porosität ->mm

print boden_e_vol
print 'z',tiefe, 'para',size(soil_m[0,:,0]), 't',size(soil_m[:,:,0])

a=atm_input()
#print a.in_all(sample_date,lat)[0,:]
#print a.in_all(sample_date,lat+25)[0,:]

soil,genu_soil,genu_para=b_bw.genu_soil[1],b_bw.genu_soil,b_bw.genu_para
  
#wasser
soil_m[0,0,0]=b_bw.genu_para[0,1]              #oberhalb Boden: Saettigung (check position soil abh.)
soil_m[:,0,0]=0.3                             #Anfangswerte setzen
soil_m[5,0,0]=0.1
soil_m[6:,0,0]=0.25   

#Potential
soil_m[:,1,0]=b_bw.potential(soil,genu_soil,genu_para,soil_m[:,0,0])   #hPa (=-cm)

niederschlag=1
if niederschlag == 0:
    soil_m[0,1,0]=pot_verd     #hPa (=-cm)

#leitfaehigkeit
soil_m[:,2,0]=b_bw.unsat_k_pot(soil,genu_soil,genu_para,soil_m[:,0,0])  #cm/d
soil_m[:,2,0]=soil_m[:,2,0]*dt                                          #umrechnung in cm/zeiteinheit
#Po'
P0=1
soil_m[0,3,0]=P0
soil_m[1:,3,0]=(soil_m[1:,1,0]-soil_m[:tiefe-1,1,0])/h

#----------------------------------------


W0=0.35
W00=0.25

#for i in range(0,t_n):
for i in range(0,1):
    print i, 'I'
    
    W=soil_m[:,0,i]
    W_k_calc=zeros(size(soil_m[:,0,i]),float)
    P=soil_m[:,1,i]
    k=soil_m[:,2,i]
    P_diff=soil_m[:,3,i]
    #initialfluss
    F=k*(P_diff-1)*dt/h

    sum_tau=0
    tau=dt
    
    #Bestimmung Fluss (cm/d) + variabler zeitschritt dt
    while sum_tau <= dt:

        print 'while', sum_tau, dt,tau,i
        
        ###oberste schicht - luft beruecksichtigen!!!!!!!!!!!!!! 
        #fliessrichtung 
        down, down_grav, up = where(P_diff < 0)[0], where(P_diff == 0)[0] , where(P_diff > 0)[0]
        
        #Wassergehalt zur k bestimmung
        anteil=0.2                
        W_k_calc[down] = W[down-1]-anteil*(W[down-1]-W[down])/2
        W_k_calc[down_grav]=W[down_grav]
        if max(up) >= size(W)-1:
            W_k_calc[up[:size(up)-1]]=W[up[:size(up)-1]]-anteil*(W[up[:size(up)-1]]-W[up[:size(up)-1]-1])/2
        else:
            W_k_calc[up]=W[up]-anteil*(W[up]-W[up+1])/2
        
        #k bestimmung
        k_calc=b_bw.unsat_k_pot(soil,genu_soil,genu_para,W_k_calc)*dt

        #fluss mit groesseren k von beiden zellen        
        F=(k_calc*(P_diff-1.)*tau)/h

        ########################################################################
        #Flussregulation zelle darf nicht nachbarzelle uebersteign 
        #Delta Wasser - Differenzen der Wassergehalte (kleinere der beiden nachbarzellen)
        D_W_oben=zeros(size(W),float)
        D_W_oben[1:]= absolute(W[:size(W)-1]-W[1:])

        D_W_unten=zeros(size(W),float)
        D_W_unten[1:size(W)-1]= absolute(W[2:]-W[1:size(W)-1])

        unten=where(D_W_unten < D_W_oben)
        oben=where(D_W_unten > D_W_oben)
        D_W=D_W_unten
        D_W[oben]=D_W_oben[oben]
        
        #kleine wasserdifferenzen ignorieren
        D_W[where(D_W < 0.01* b_bw.genu_para[0,1])]=10
        
        D_tau=h*absolute(D_W[1:]/(2*(k_calc[:size(W)-1]*(P_diff[:size(W)-1]-1)-k_calc[1:]*(P_diff[1:]-1))))
        t_min=min(D_tau)
#        
#        #groesster initial Fluss, ma zelle mit groestem input, mi zelle mit groesstem output
#        ma=max(-F[1:tiefe-1]+F[2:])
#        mi=min(-F[1:tiefe-1]+F[2:])
#
#        #positionen
#        ma_po=where((-F[1:tiefe-1]+F[2:]) == ma)[0]+1
#        mi_po=where((-F[1:tiefe-1]+F[2:]) == mi)[0]+1
#        #infiltr. oberflaechenwasser ist max
#        if ma_po ==1 and mi_po <> 2:
#            mi_po=0
#        
#        #Richtung und Position
#        #?? gibt es die situation, dass max i und max out nicht beieinander sind?
#        
#        #spaetester ausgleichswert-wassergehalt
#        up_down_pos= -1     #  Abwaerts
#        if ma_po-mi_po < 0:         #(hochwaerts)
#            up_down_pos= 1 
#        #ausgleichswassergehalt zwischen den zellen  
#        Q_mitte=(W[ma_po+up_down_pos]+W[ma_po])/2.
#        if mi_po == 0:              #ueberstau
#            Q_mitte=b_bw.genu_para[0,1]
#        #schnellstes k
#        k_t0=k[ma_po+up_down_pos]
#        #langsamstes k
#        k_t00= b_bw.unsat_k_pot(soil,genu_soil,genu_para,Q_mitte)*dt 
#        #mittelers k
#        k_mean=(k_t0+k_t00)/2
#        print k_t0, k_mean, k_t00, ma_po, ma, mi
#        
#        t_mean=(W[ma_po]-Q_mitte)*h/(k_mean*(P_diff[ma_po]-1))
#        
#        print 'tmittel', t_mean
#        print 'tschnell', (W[ma_po]-Q_mitte)*h/(k_t0*(P_diff[ma_po]-1))
#        print 'tlangsam', (W[ma_po]-Q_mitte)*h/(k_t00*(P_diff[ma_po]-1))
#        print 'zeitschritt', dt,tau

        ##Bedingung: beachtung der variablen geschwindigkeit des flusses (dt wird verkleinert)
        inter_tau=0
        if t_min > dt*0.1:
            
            print 'ok', tau, tau*0.1,t_min        
        
            print'....----.....'
            #groesster initial Fluss, ma zelle mit groestem input, mi zelle mit groesstem output
            ma=max(-F[1:tiefe-1]+F[2:])
            mi=min(-F[1:tiefe-1]+F[2:])
            #position des max fluss
            ma_po=where((-F[1:tiefe-1]+F[2:]) == ma)[0]+1
            print F
            mi_po=where((-F[1:tiefe-1]+F[2:]) == mi)[0]+1
            print t_min, ma, ma_po, mi_po
            #infiltr. oberflaechenwasser ist max
            if ma_po ==1 and mi_po <> 2:
                mi_po=0
            #Richtung und Position
            #?? gibt es die situation, dass max i und max out nicht beieinander sind?
        
            #spaetester ausgleichswert-wassergehalt
            up_down_pos= -1     #  Abwaerts
            if (-F[ma_po]) < (-F[ma_po+1]):         #(hochwaerts)
                up_down_pos= 1
            print up_down_pos
            #ausgleichswassergehalt zwischen den zellen  
            Q_mitte=(W[ma_po+up_down_pos]+W[ma_po])/2.
       
            del_Q=(W[ma_po+up_down_pos]-Q_mitte)     #wie oben als wassergehalt ausgedrueckt 
 
            #Wassergehalt fuer k berechnung
            intervalle=[0.1,0.2,0.3,0.4]
            anteil=[0.05,0.2,0.45,0.8]  #(1-(1*sum(bisher)+intrevall[*]*0.5))
            anteil_delta_Q = W[ma_po+up_down_pos] - del_Q * anteil
#            print del_Q ,sum(del_Q * intervalle), anteil_delta_Q
                     
            for new_t in range(0,size(intervalle)):

                print 'schleife',new_t, t_min
                if new_t > 0:
                    #fliessrichtung 
                    P=b_bw.potential(soil,genu_soil,genu_para,W)
                    P_diff[0]=P0
                    P_diff[1:]=(P[1:]-P[:tiefe-1])/h
                    down, down_grav, up = where(P_diff < 0)[0], where(P_diff == 0)[0] , where(P_diff > 0)[0]
                
                ##mittlerer k wert fuer zeitabschnitt, vielleicht besser 75% wert oder 2/3 oder geometrisches mittel
                k_tau=b_bw.unsat_k_pot(soil,genu_soil,genu_para,anteil_delta_Q[new_t])*dt 
              
                #benoetigte zeit
                tau=absolute((-del_Q*intervalle[new_t])*h/(k_tau*(P_diff[ma_po]-1)))
                                    
                #Wassergehalt zur k bestimmung                
                W_k_calc[down] = W[down-1]-anteil[new_t]*(W[down-1]-W[down])/2
                W_k_calc[down_grav]=W[down_grav]

                if max(up) >= size(W)-1:
                    W_k_calc[up[:size(up)-1]]=W[up[:size(up)-1]]-anteil[new_t]*(W[up[:size(up)-1]]-W[up[:size(up)-1]-1])/2
                else:
                    W_k_calc[up]=W[up]-anteil[new_t]*(W[up]-W[up+1])/2

                #k bestimmung
                k_calc=b_bw.unsat_k_pot(soil,genu_soil,genu_para,W_k_calc)*dt
                #Fluss bestimmung
                F_calc=k_calc*(P_diff-1)*tau/h          
                
                W[:size(W)-1]=W[:size(W)-1]-(F_calc[:size(W)-1]-F_calc[1:])
                W[0]=W0
                W[size(W)-1]=W00
              
              ##benoetigte zeit darf nihct dt ueberschreiten  
                if (inter_tau+tau) > t_min:
                    tau=t_min-inter_tau
                    
                    F_calc=k_calc*(P_diff-1)*tau/h          
                    
                    W[:size(W)-1]=W[:size(W)-1]-(F_calc[:size(W)-1]-F_calc[1:])
                    W[0]=W0
                    W[size(W)-1]=W00
                    sum_tau=sum_tau+tau

                    break             

                sum_tau=sum_tau+tau
                inter_tau=inter_tau+tau


        else:
            if t_min < dt and t_min >0:
                F=F*t_min/tau
                tau=t_min
            
            ##benoetigte zeit darf nihct dt ueberschreiten  
            if (sum_tau+tau) > dt:
                print tau, t_min
                tau=dt-sum_tau
                print tau, t_min
                
                F_calc=k_calc*(P_diff-1)*tau/h          
                
                W[:size(W)-1]=W[:size(W)-1]-(F_calc[:size(W)-1]-F_calc[1:])
                W[0]=W0
                W[size(W)-1]=W00

                sum_tau=sum_tau+tau

                break
            
            sum_tau=sum_tau+tau
            W[:size(W)-1]=W[:size(W)-1]-(F[:size(W)-1]-F[1:])
            W[0]=W0
            W[size(W)-1]=W00

#            ########################################################################
#            #Flussregulation zelle darf nicht nachbarzelle uebersteign 
#            #Delta Wasser - Differenzen der Wassergehalte
#            D_W_oben=zeros(size(W),float)
#            D_W_oben[1:]= absolute(W[:size(W)-1]-W[1:])
#            print D_W_oben
#            D_W_unten=zeros(size(W),float)
#            D_W_unten[1:size(W)-1]= absolute(W[2:]-W[1:size(W)-1])
#            print D_W_unten
#            unten=where(D_W_unten < D_W_oben)
#            oben=where(D_W_unten > D_W_oben)
#            D_W=D_W_unten
#            D_W[oben]=D_W_oben[oben]
#            print D_W
#            D_W[where(D_W < 0.01* b_bw.genu_para[0,1])]=10
#            print D_W
#            print 'DW'
#            
#            D_tau=h*absolute(D_W[1:]/(2*(k_calc[:size(W)-1]*(P_diff[:size(W)-1]-1)-k_calc[1:]*(P_diff[1:]-1))))
#            print D_tau
#            print 'ddd'
#            print (F[:size(W)-1]-F[1:])
#            print min(D_tau)
#            t_min=min(D_tau)
            
            
            
#            #Flussregulation zelle darf nicht nachbarzelle uebersteign 
#            F_max=zeros(size(W),float)
#            #zuwachs und von welcher zelle
#            plus_water=where(-(F[:size(W)-1]-F[1:]) > 0)[0]
#            
#            pw_oben=where(-F[plus_water] > F[plus_water+1])[0]
#            pw_unten=where(-F[plus_water] < F[plus_water+1])[0]
#            
#            F_max[plus_water[pw_oben]]=absolute((W[plus_water[pw_oben]]-W[plus_water[pw_oben]-1])/2)
#            F_max[plus_water[pw_unten]]=absolute((W[plus_water[pw_unten]]-W[plus_water[pw_unten]+1])/2)
#            print F_max
#
#            #entwaeserung un in welche zelle
#            minus_water=where(-(F[:size(W)-1]-F[1:]) < 0)[0]
#            
#            mw_oben=where(-F[minus_water] < F[minus_water+1])[0]
#            mw_unten=where(-F[minus_water] > F[minus_water+1])[0]
#            
#            F_max[minus_water[mw_oben]]=absolute((W[minus_water[mw_oben]]-W[minus_water[mw_oben]-1])/2)
#            F_max[minus_water[mw_unten]]=absolute((W[minus_water[mw_unten]]-W[minus_water[mw_unten]+1])/2)
#            
#            print plus_water ,minus_water
#            print mw_oben, mw_unten
#            print F_max
#            print (F[:size(W)-1]-F[1:])
#            F_max_n=zeros(size(W),float)
#            F_max_n[plus_water] = F_max[plus_water]+(F[plus_water]-F[plus_water+1])#kleiner 0?
#            F_max_n[minus_water] = F_max[minus_water]-(F[minus_water]-F[minus_water-1])#kleiner 0?
#            
#            pos=where(F_max_n == min(F_max_n))[0]
#            print pos
#            t_min=-(F_max[pos])*h/(k[pos]*(P_diff[pos]-1))
       
 
        
        print '#####################'
    
        print 'neu_tau', t_min,tau
        print 'zeit:', sum_tau
        print W
        P=b_bw.potential(soil,genu_soil,genu_para,W)
        P_diff[0]=P0
        P_diff[1:]=(P[1:]-P[:tiefe-1])/h
        tau=dt

#        if sum_tau < 0.05 or sum_tau >0.1 and sum_tau<0.101 or sum_tau >0.3 and sum_tau<0.301 or sum_tau >0.5 and sum_tau<0.54 or sum_tau >0.7 and sum_tau<0.75 or sum_tau >0.95 and sum_tau<0.98:
#            plt.plot(W)
#            plt.show()
    print '-----------------------------------'
    print 'zeit:', sum_tau
    print W
    plt.plot(W)
    plt.show()


