# -*- coding: utf-8 -*-
"""
Created on Mon Feb 20 11:53:10 2012 @author: tengen
"""
#Main: Aufrufen der Module

from numpy import *
import guiqwt.pyplot as plt 
from os import chdir as chdir
from atm_in import *
import boden_bewegung as b_bw
import delta_konzentrationen as d_c
from time import time

zeit1=time()


#Lösungsmatrix: Anzahl- Tiefe, Prameter, Zeit
"""
    |------- t
 z0 |      |  
    |      |  Parameter (Wassergehalt,isotope)
 zn |      |
    |------|
"""
profil_tiefe=300        #cm
h=5.                   #bodenschichtendicke in modellierung
profil=arange(h,profil_tiefe+h,h)
profil=-profil

calc_time=900.0            #tage

hour,day,month=1./24.,1.,30.
dt=day                  #eregbnisausgabe in stunden-hour, tage-day, monate-month

##Bodenarten
boden_schicht_1='Ut2'#'Ut2'#'Ss'#'Sl2'
BS_1=boden_schicht_1
boden_1_maechtig=profil_tiefe

boden_schicht_2='Ut2'
BS_2=boden_schicht_2
boden_2_maechtig=profil_tiefe
  
##Randbedinungen k-berechnungsmethode         
##0,1,2  Stauer - 1, 
##GW mit festem gesaettigtem Wassergehalt/Potential - 0,
##kein Stauer mit  Wassergehalt/Potential wie zelle oberhalb-2,
stauer=0

k_calc_method=1     #methoden um k zu bestimmen(0,1-2-3)

tiefe,t_n=int(round(profil_tiefe/h+2)),int(round(calc_time/dt))

M1=int(1+boden_1_maechtig/h)
M2=int(1+boden_2_maechtig/h)
print M1,M2
if profil_tiefe==M1:
    M1=M1+2
if profil_tiefe >= boden_2_maechtig:
    M2=tiefe  
print M1,M2    
    
soil_m=zeros((tiefe,t_n+1,3),float)
soil_m[:]=0
print 'z',tiefe, 't',t_n+1

boden_e_vol=h*b_bw.genu_para[0,1]     #boden_schicht_tiefe*nutzbare porosität ->mm
Verd, Infil,out_flow,in_flow=0,0, 0,0                              ##Verdunstung als Summe
print boden_e_vol


##Atmosphaere
#------------------------------------------------------------------------------#
#a=atm_input()

surface_runoff=0

a=atm_input()
atm = a.in_all(sample_date,lat)

N_in=atm[:,1]/30*dt
N_in=N_in[::-1]/10.              #(mm zu cm)
d_Iso_in=atm[:,0][::-1]
ETP_in=atm[:,3]/30*dt

ETP_in=ETP_in[::-1]/10.


###maximale sinnvole Modeliierung:    
if dt == month and t_n > size(N_in):
    t_n=size(N_in)
    calc_time=t_n*30
if dt == day and t_n >size(N_in)*30:
    t_n=size(N_in)*30
    calc_time=t_n
if dt == hour and t_n >size(N_in)*30*24:
    t_n=size(N_in)*30*24
    calc_time=t_n/24

##Niederschlag, Delta Isotope
N=zeros(t_n+1,float)
d_O=zeros(t_n+1,float)
ETP=zeros(t_n+1,float)
for nm in range (0,int(calc_time/30)):
    N[nm*30/dt:(nm+1)*30/dt]=N_in[nm]
    d_O[nm*30/dt:(nm+1)*30/dt]=d_Iso_in[nm]
    ETP[nm*30/dt:(nm+1)*30/dt]=ETP_in[nm]

if int(calc_time/30)==0:
    nm=0
N[(nm+1)*30/dt:t_n+1]=N_in[nm+1]
d_O[(nm+1)*30/dt:t_n+1]=d_Iso_in[nm+1]
ETP[(nm+1)*30/dt:t_n+1]=ETP_in[nm+1]

d_O=d_O[::-1]
N=N[::-1]
ETP=ETP[::-1]
d_H=8.*d_O+10.

##ETP von cm in saugspannung umrechnen  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
atm_pot=ETP
#atm_pot[:]=-100.


#Konzentrationen Isotope
c_O=d_c.konz_delta(d_O,d_H)[0]
c_H=d_c.konz_delta(d_O,d_H)[1]

#------------------------------------------------------------------------------#
#N[:]=0.5#0.5#0.5#N*10


##Isotope Anfangsbedinungen
c_iso=zeros((tiefe,2),float)
c_iso[:,0]=mean(c_O)
c_iso[:,1]=mean(c_H)

soil_m[:,0,1]=c_iso[:,0]
soil_m[:,0,2]=c_iso[:,1]

##Bodenart und nutzbare porosität
genu_soil,genu_para=b_bw.genu_soil,b_bw.genu_para

soil_class=['']*tiefe
soil_class[0]='atmo'

n=zeros(tiefe,float)
n[0]=1
k_sat=zeros(tiefe,float)
k_sat[0]=1
W_wp=zeros(tiefe,float)
P_wp=zeros(tiefe,float)
P_wp[:]=-15000.
for s in range(1,M1):
    soil_class[s]=BS_1
    n[s]=b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[1]
    k_sat[s]=b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[5]
    W_wp[s]=b_bw.theta(boden_schicht_1,genu_soil,genu_para,P_wp[s])
for s in range(M1,M2):
    soil_class[s]=BS_2
    n[s]=b_bw.soil_genu_parameter(boden_schicht_2,genu_soil,genu_para)[1]
    k_sat[s]=b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[5]
    W_wp[s]=b_bw.theta(boden_schicht_2,genu_soil,genu_para,P_wp[s])
print soil_class

################################################################################

#wasser Anfangsbedinungen
print N[0]
soil_m[0,0,0]=N[0]             #oberhalb Boden: Saettigung (check position soil abh.)
soil_m[1:,0,0]=0.3#0.086#n[1:]                             #Anfangswerte setzen
#soil_m[1,0,0]=0.4#n[1]
#soil_m[2,0,0]=0.3
#soil_m[3,0,0]=0.25
#soil_m[4,0,0]=0.2
#soil_m[5,0,0]=0.15
#soil_m[6,0,0]=0.1



##Minimum an Wassergehalt (sonst wird Potential Unendlich)
soil_m[where(soil_m[1:,0,0]==0),0,0]=b_bw.soil_genu_parameter(boden_schicht_2,genu_soil,genu_para)[0]+1./1000.
soil_m[where(soil_m[1:M1,0,0]==0),0,0]=b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[0]+1./1000.

if stauer == 0:
    soil_m[tiefe-1,0,0]=n[tiefe-1]                        #gesaettigt
if stauer == 2:                                         # wert wie zelle oberhal
    soil_m[tiefe-1,0,0]=soil_m[tiefe-2,0,0] 
    
 #Potential mit Schichten
def Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,Wa):
    Po=zeros(tiefe,float)
    Po[1:M1]=b_bw.potential(BS_1,genu_soil,genu_para,Wa[1:M1])   #hPa (=-cm)
    Po[M1:M2]=b_bw.potential(BS_2,genu_soil,genu_para,Wa[M1:M2])   #hPa (=-cm)
    #Rand
    Po[0]=Wa[0] #Po[1]
    Po[tiefe-1]=Po[M2-1]
    
    niederschlag=1
    if niederschlag == 0:
        Po[0]=pot_verd     #hPa (=-cm)
    return Po

#leitfaehigkeit mit Schichten
def ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,Pot):
    ko=zeros(tiefe,float)
    ko[1:M1]=b_bw.unsat_k_pot(BS_1,genu_soil,genu_para,Pot[1:M1])   #cm/d
    ko[M1:M2]=b_bw.unsat_k_pot(BS_2,genu_soil,genu_para,Pot[M1:M2]) 
    #Rand
    if Pot[0]>0:
        ko[0]=k_sat[1]
    else:
        ko[0]=ko[1]
        
    ko[tiefe-1]=ko[M2-1]
    
    ko=ko*dt                                        #umrechnung in cm/zeiteinheit
    return ko

P0=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,soil_m[:,0,0])  
k0=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,P0)

#Po'
P_diff_0=zeros(tiefe,float)
#!!!!!!!!!!!!!!!!!!!!!#
P_diff_0[0]=N[0]

#!!!!!!!!!!!!!!!!!!!!!#
P_diff_0[1:]=(P0[1:]-P0[:tiefe-1])/h      ##???? h*n ???? ####

#print soil_m[:,0,0]
#print sum(soil_m[:,0,0])
#print soil_m[:,0,1]*5
#print P_diff_0
#print 'p_diff'
#----------------------------------------




###########################################################
####hydraulisch vergleich###
w_test=zeros(16,float)
w_test[0]=0.09
for wt in range(1,16):
    w_test[wt]=0.1+wt*0.025
w_test[wt]=n[1]


p_test=b_bw.potential(BS_1,genu_soil,genu_para,w_test)
k_test=b_bw.unsat_k_pot(BS_2,genu_soil,genu_para,p_test)
#plt.plot(w_test,p_test)  
#plt.show()
#plt.plot(w_test,k_test)
#plt.show()
##################
#############################################################









for i in range(0,t_n):
    print ''
    print i, 'I'
    
    ################
#    if i>50:
#        N[i]=0
    ################

    c_iso[0,0]=c_O[i]
    c_iso[0,1]=c_H[i]
    
    if i > 0:
        W[0]=N[i]
        W[where(W[M1:]<=b_bw.soil_genu_parameter(boden_schicht_2,genu_soil,genu_para)[0])]=b_bw.soil_genu_parameter(boden_schicht_2,genu_soil,genu_para)[0]+1./1000.
        W[where(W[1:M1]<=b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[0])]=b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[0]+1./1000.
        
        P=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,W)
        P[0]=N[i]
        if N[i] == 0.:
            P[0]= atm_pot[i]       ##atm verdunstung einsetzen
        
        k=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,P)
              
        #!!!!!!!!!!!!!!!!!!!!!#
        P_diff[0]=N[i]
        #!!!!!!!!!!!!!!!!!!!!!#
        P_diff[1:]=(P[1:]-P[:tiefe-1])/h
        
        soil_m[:,i,0]=W
        F=k*(P_diff-1)*1/(h)        ##als anteil wasser ausgedrueckt
    
    else:
        W=zeros(tiefe,float)        
        W[:]=soil_m[:,i,0]
        W[0]=N[i]
        W_k_calc=zeros(tiefe,float)
        k_calc=zeros(tiefe,float)
        F_delta=zeros(tiefe,float)
        P=P0
        P_diff=P_diff_0
        
        P[0]=N[i]
        if N[i] == 0:
            P[0]= atm_pot[i]      ##atm verdunstung einsetzen
            P_diff[1]=(P[1]-P[0])/h

        k=k0
        
        #initialfluss 
        F=k0*(P_diff-1)*1/(h)     ##als anteil wasser ausgedrueckt
    
    sum_tau=0.
    tau=1.          ### 1 Zeiteinheit (nach Wahl)
    step_while=0
    
    #Bestimmung Fluss (cm/d) + variabler zeitschritt dt
    while sum_tau < 1:
        step_while=step_while+1

        ###oberste schicht - luft beruecksichtigen!!!!!!!!!!!!!! 
   #############################################################################     
        #fliessrichtung 
        down, down_grav, up = where(P_diff < 0)[0], where(P_diff == 0)[0] , where(P_diff > 0)[0]

        ########################k_calc
        if k_calc_method <= 1:
            #Wassergehalt zur k bestimmung
            anteil=0.5
            if anteil <> 0.5:            
                W_k_calc[down] = W[down-1]-anteil*(W[down-1]-W[down])/2
                W_k_calc[down_grav]=W[down_grav]
                if max(up) >= size(W)-1:
                    W_k_calc[up[:size(up)-1]]=W[up[:size(up)-1]]-anteil*(W[up[:size(up)-1]]-W[up[:size(up)-1]-1])/2
                else:
                    W_k_calc[up]=W[up]-anteil*(W[up]-W[up+1])/2
            else:
                W_k_calc[1:]=(W[1:]+W[:size(W)-1])/2
            
            if W[0]<=0:
                W_k_calc[0]=(W[1]+W[1]-n[1]*0.1)/2.
                W_k_calc[1]=(W[1]+W[1]-n[1]*0.1)/2.  ##weniger wie tasaechlich da max 10% verdunsten duerfen
                
            else:
                W_k_calc[1]=(n[1]+W[1])/2
 
            #k bestimmung
            P_k_calc=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,W_k_calc)
            k_calc=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,P_k_calc)

        elif k_calc_method == 2:
            ##mittelwert
            k_calc[1:]= (k[1:]+k[:tiefe-1])/2

            if W[0]<=0:
                W_k_calc[0]=W[1]-n[1]*0.1
                W_k_calc[1:]=W[1:]
                P_0=b_bw.potential(BS_1,genu_soil,genu_para,W_k_calc)
                k_0=b_bw.unsat_k_pot(BS_1,genu_soil,genu_para,P_0)
                k_calc[0]=(k_0[0]+k[1])/2
                k_calc[1]=(k_0[0]+k[1])/2
            else:
                k_calc[1]=(k_sat[1]+k[1])/2

            
        elif k_calc_method == 3:
            ##geometrisches mittel            
            k_calc[1:]= (k[1:]*k[:tiefe-1])**0.5

            if W[0]<=0:
                W_k_calc[0]=W[1]-n[1]*0.1
                W_k_calc[1:]=W[1:]
                P_0=b_bw.potential(BS_1,genu_soil,genu_para,W_k_calc)
                k_0=b_bw.unsat_k_pot(BS_1,genu_soil,genu_para,P_0)
                k_calc[0]=(k_0[0]*k[1])**0.5
                k_calc[1]=k_calc[0]
            else:
                k_calc[1]=(k_sat[1]*k[1])**0.5


        ##Uebergang in anderen horizont
        if M1 < tiefe-1:
            k_calc[M1]=min(k_calc[M1], k_calc[M1-1])

#        stauer=1
        if stauer == 1:             #undurchlassig/stauer
            k_calc[tiefe-1]=0
    
   #############################################################################

        ########################################################################
        #Flussregulation zelle darf nicht nachbarzelle uebersteign 
        #Delta Wasser - Differenzen der Wassergehalte (kleinere der beiden nachbarzellen)

        P_neg=P_diff[where(P_diff<=0)]

        flow=k_calc*(P_diff-1)/(h)
        
        if P_diff[1]<0 and W[0]<=0:
            flow[0:2]=0

#        print flow
        flow[:tiefe-1]=(flow[:tiefe-1]-flow[1:])

        ####        
        flow[0], flow[tiefe-1]=0,0
        ##Randbedinungen##
        
#        print flow
        delta=1.
        d_tau=1.
        MIN=0.01
        crit=MIN
        up_bound,down_bound=1., MIN

        while delta > 0:
            W_neu=W-flow*d_tau
            P_neu=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,W_neu)
            P_diff_neu=P_neu[1:]-P_neu[:tiefe-1]
            
            if size(where(P_diff_neu > 1.0)) > 0:
                up_bound=d_tau
                d_tau=d_tau/2
                delta=1
                if d_tau < MIN:
                    delta=0
            else:
                if size(where(P_diff_neu < 1.0 - crit )) == size(P_diff):
                    down_bound=d_tau
                    d_tau=(up_bound+d_tau)/2
                    delta=1
                else:
                    delta=0
                    

        
            
        
        D_W_oben=zeros(size(W),float)
        D_W_oben[1:]= absolute(W[:size(W)-1]-W[1:])

        D_W_unten=zeros(size(W),float)
        D_W_unten[1:size(W)-1]= absolute(W[2:]-W[1:size(W)-1])

        unten=where(D_W_unten < D_W_oben)
        oben=where(D_W_unten > D_W_oben)
        D_W=D_W_unten
        D_W[oben]=D_W_oben[oben]
        
        #kleine wasserdifferenzen ignorieren
        D_W[where(D_W < 0.0001)]=10
        if sum(D_W)==tiefe*10:
            t_min=1
         
        else:
            D_tau=h*absolute(D_W[1:tiefe-1]/(2*(k_calc[1:tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))))
            D_tau[where(k_calc[1::tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))==0]=1
            
            if stauer == 1:
                D_tau=h*absolute(D_W[1:tiefe-1]/(2*(k_calc[1:tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))))
                D_tau[where(k_calc[1::tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))==0] = 1
            
            t_01_down=h*absolute(  0.1  *n[1:tiefe-1]/((k_calc[1:tiefe-1]*(P_diff[1:tiefe-1]-1)-k_calc[2:]*(P_diff[2:]-1))))
            
            t_min=min(min(D_tau[:]),min(t_01_down))

        ##darf max das oberflaechenwasser infiltrieren 
        if W[0] > 0:
            t_min=min(absolute(W[0]/(k_calc[1]*(P_diff[1]-1))), t_min)
        
        ##Reduzierung der Zeit fuer die Verdunstung
        if W[0] == 0:
#            print '==0',t_min
            t_min=min(h*absolute(n[1] * 0.1 /(k_calc[1]*(P_diff[0]-1))), t_min)


            
        if t_min*0 <> 0 :
            if dt==hour:
                t_min=0.1           ##6min
                print 'nan'
            if dt==day:
                t_min=1./24.        ##1h
            if dt==month:
                t_min=1./60.        ##1/2d
        
        if t_min == 0:
            if dt==hour:
                t_min=0.01        ##36sec
            if dt==day:
                t_min=1./240.              ##6min
            if dt==month:
                t_min=1./600.           ##1.2h
        
        if t_min > 0.1:
#            print t_min, d_tau
            t_min=0.1
#            print '>0'
#            plt.plot(W)
#            plt.show()
#        t_min=0.00006944444444444
################################################################################
################################################################################

        if t_min < 1 and t_min >0:
            
#            print d_tau, t_min

            tau=t_min
            ##benoetigte zeit darf nicht dt ueberschreiten  
            if (sum_tau+tau) > 1:
                tau=1-sum_tau                
            
            ##fliessende wasseranteile
            F_calc=k_calc*(P_diff-1)*tau/(h)

            while max(F_calc) > n[where(F_calc[:]==max(F_calc))[0][0]] or min(F_calc) < -n[where(F_calc[:]==min(F_calc))[0][0]]:
                tau=tau/2
                F_calc=k_calc*(P_diff-1)*tau/(h)

##########################            
#            tau=d_tau
#            if (sum_tau+tau) > 1:
#                tau=1-sum_tau
#            F_calc=k_calc*(P_diff-1)*tau/(h)
#            ############       

            if W[0] >0:
                F_calc[0]=0
            elif F_calc[1] < 0:
                F_calc[1] = 0
            if W[0]<=0:
                F_calc[1]=atm_pot[i]/h*(W[1]-W_wp[1])/(n[1]*0.75)*tau

            if stauer == 1:               #undurchlassig/stauer
                F_calc[tiefe-1]=0
            
            F_delta[:tiefe-1]=(F_calc[:tiefe-1]-F_calc[1:])

            ##saettigung                    
            voll= where(W[1:]-F_delta[1:] > n[1:])[0]+1

            while sum(voll)>0:
#                print 'voll',voll#, sum(voll)
                for v in (voll[::-1]):

                    #von oben nicht von unten
                    if F_calc[v] < 0 and F_calc[v+1] == 0:
                        F_calc[v]=(W[v]-n[v])

                    #von oben und nach unten (hoffentlich kleiner nach unten)
                    elif F_calc[v] < 0 and F_calc[v+1] < 0:
                        F_calc[v]=(W[v]-n[v])+F_calc[v+1]   #F_calc[v+1] durch vorige Schritte vorgegeben
                    
                    #von oben und von unten
                    elif F_calc[v] < 0 and F_calc[v+1] > 0:                   
#                        print 'spezialfall ueberpruefen'
                        F_calc[v]= F_calc[v]*(W[v]-n[v])/(F_calc[v]-F_calc[v+1])
                        F_calc[v+1]= F_calc[v+1]*(W[v]-n[v])/(F_calc[v]-F_calc[v+1])         
 
                    ########################################################
                    #von unten, nichts von oben
                    elif F_calc[v] == 0 and F_calc[v+1] > 0:
                        F_calc[v+1]=-(W[v]-n[v])                 

                    #nach oben (hoffentlich kleiner nach unten) und von unten
                    elif F_calc[v] > 0 and F_calc[v+1] > 0:
                        F_calc[v+1]=-(W[v]-n[v])+F_calc[v]
                    
                if stauer == 1:               #undurchlassig/stauer
                     F_calc[tiefe-1]=0
                
                F_delta[:tiefe-1]=(F_calc[:tiefe-1]-F_calc[1:])

                voll= (where((W[1:]-F_delta[1:]).round(6) > n[1:].round(6))[0])+1
    
            ################################################################
            
            ########
            ##ISOTOPE##
            for is_m in range(1, tiefe-1):
                ##Unterteilung der Mischung - wichtig bei grossen ausfluessen
#                step=1
#                if F_calc[is_m] > 0 or F_calc[is_m+1] < 0:
#                    if F_calc[is_m] > 0.1 or F_calc[is_m+1] < -0.1:
#                        step=10
#                    elif F_calc[is_m] > 0.05 or F_calc[is_m+1] < -0.05:
#                        step=5
#                    elif F_calc[is_m] > 0.01 or F_calc[is_m+1] < -0.01:
#                        step=2
               ##welche isotopenkonzentrationen fluss in oder aus zelle  
                step=1
                if F_calc[is_m] > 0:
                    c_oben_O = c_iso[is_m,0]
                    c_oben_H = c_iso[is_m,1]
                else:
                    c_oben_O = c_iso[is_m-1,0]
                    c_oben_H = c_iso[is_m-1,1]
                    
                if F_calc[is_m+1] < 0:
                    c_unten_O = c_iso[is_m,0]
                    c_unten_H = c_iso[is_m,1]
                else:
                    c_unten_O = c_iso[is_m+1,0]
                    c_unten_H = c_iso[is_m+1,1]

                ##mischung in step schritten
                W_0,c_iso_O_0, c_iso_H_0 = W[is_m],c_iso[is_m,0],c_iso[is_m,1]
                F_o, F_u = F_calc[is_m]*1/step, F_calc[is_m+1]*1/step
                        
#                print c_iso[is_m],W_0,c_iso_H_0
                for im in range(0,step):
#                    print im, step
                    I_H=(W_0*c_iso_H_0- (F_o*c_oben_H - F_u*c_unten_H))/(W_0-(F_o - F_u))
                    I_O=(W_0*c_iso_O_0- (F_o*c_oben_O - F_u*c_unten_O))/(W_0-(F_o - F_u))
                    W_0, c_iso_H_0, c_iso_H_0 = W_0-(F_o-F_u), I_O, I_H

                c_iso[is_m,0]=I_O
                c_iso[is_m,1]=I_H
#------------------------------------------------------------------------------#
            ##########
            ##Wasserfluss##
            if F_calc[1] > 0:
                Verd=Verd+F_calc[1]*h
                F_delta[0]=0
#                W[0]=0
            else:
                Infil=Infil-F_calc[1]*h
                F_delta[0]=-F_calc[1]*h

            if F_calc[tiefe-1] < 0:
                out_flow=out_flow+F_calc[tiefe-1]*h#*n[tiefe-2]            
            if F_calc[tiefe-1] > 0:               
                in_flow=in_flow+F_calc[tiefe-1]*h#*n[tiefe-2]     
            
            W=W-F_delta
            if W[0] < 1./1000.:
                W[0]=0

            W[where(W[M1:]<b_bw.soil_genu_parameter(boden_schicht_2,genu_soil,genu_para)[0]+1./1000.)]=b_bw.soil_genu_parameter(boden_schicht_2,genu_soil,genu_para)[0]+1./1000.
            W[where(W[1:M1]<b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[0]+1./1000.)]=b_bw.soil_genu_parameter(boden_schicht_1,genu_soil,genu_para)[0]+1./1000.

            if stauer == 0:
                W[tiefe-1]=n[tiefe-1]                   #gesaettigt
            if stauer == 2:                             # wert wie zelle oberhal
                 W[tiefe-1]=W[tiefe-2] 
                
            P=Po(BS_1,BS_2,M1,M2,genu_soil,genu_para,W)

            P[0]=W[0]
            P_diff[0]=W[0]-P[1]
            if W[0] <= 0:
                P[0]= atm_pot[i]       ##atm verdunstung einsetzen]
                P_diff[0]=(atm_pot[i]-P[1])/h

            P_diff[1:]=(P[1:]-P[:tiefe-1])/h                

            k=ko(BS_1,BS_2,M1,M2,genu_soil,genu_para,P)

            sum_tau=sum_tau+tau

######################## while sumtau <1 #######################################
    print '-----------------------------------',step_while     
    print 'zeit:', sum_tau, i, dt, (1+i)*dt

    print sum(W), 'sum W'
    print sum(W[1:tiefe-1]), 'sum Boden'
    
    print sum(W[1:tiefe-1])*h, 'sum Boden (cm)'
    
    print Verd, 'Verdunstung'
    print Infil, 'Infiltration'
    print W[0], 'Abfluss'
    surface_runoff=surface_runoff+W[0]
    print surface_runoff, 'Abfluss kummuliert'
    print N[i], sum(N[:]), 'N aktuell, Sum N'
    print out_flow, in_flow, 'out - in'

    soil_m[:,i+1,0]=W                             #Anfangswerte setzen
    
    soil_m[:,i+1,1:3]=c_iso[:]
#    if i >21:
#        plt.plot(W) 
#        plt.show()
print '##########'
zeit2=time()
print 'Rechenzeit:',(zeit2-zeit1),'sec', (zeit2-zeit1)/60., 'min'
print sum(N[:]), 'Gesamt N'
print Infil, 'Gesamt Infiltration'
print out_flow, in_flow, 'Drainage nach unten / uptake von unten'
print sum(soil_m[1:tiefe-1,0,0])*h, 'Anfangswassergehalt'
print sum(soil_m[1:tiefe-1,i,0])*h, 'Endwassergehalt'
print Verd, 'Verdunstung'
print surface_runoff, 'Gesamtabfluss'
print sum(N[:])+sum(soil_m[1:tiefe-1,0,0])*h-(surface_runoff+sum(soil_m[1:tiefe-1,i,0])*h+Verd)+in_flow + out_flow, 'Bilanz'
plt.plot(W)
plt.show()
############################################while###############################
#print P
#print k
#print P_diff
print 'W'
print soil_m[:,i+1,0]
print 'H'

#Deltawerte Isotope
d_O=d_c.delta_konz(c_iso[:,0],c_iso[:,1])[0]
d_H=d_c.delta_konz(c_iso[:,0],c_iso[:,1])[1]

soil_m[:,:,1]=d_c.delta_konz(soil_m[:,:,1],soil_m[:,:,2])[0]
soil_m[:,:,2]=d_c.delta_konz(soil_m[:,:,1],soil_m[:,:,2])[1]


print soil_m[:,i+1,1]
print 'vergleich'

print i+1, t_n

path='F:\Enable\python_PROGRAMIERUNG'
chdir(path)
out_result='in_out_data\out_data\mo_results.csv'
output=open(out_result,'w')
for i in range (0,tiefe):
    output.writelines([str(soil_m[i,t_n,0]),';',str(soil_m[i,t_n,1]),'\n'])
output.close()

#print out_dat
#wrt_rslt=csv.writer(open(out_result,'wb'), delimiter=";")
#wrt_rslt.writerow(['Datum:',datum])
#wrt_rslt.writerow(['Ort:',txt])
#wrt_rslt.writerow(['Tracer',trcer_choice])
#wrt_rslt.writerow([])
#wrt_rslt.writerow(['Tiefe (cm)','Zeit (Monat)'])
##        wrt_rslt.writerow()
#wrt_rslt.writerows(out_dat[:,:])
print N_in[0:round(calc_time/30)]
print d_Iso_in[0:round(calc_time/30)]

##Plot Isotope
plt.plot(soil_m[:,1:t_n,1])
plt.show()
plt.plot(soil_m[0:tiefe-2,t_n,1])
plt.show()
plt.plot(soil_m[1:tiefe-2,0:t_n:10,1],profil,label='18O')
plt.legend()
plt.show()
plt.plot(soil_m[1:tiefe-2,t_n,1],profil,label='18O')
plt.legend()
plt.show()

##Plot Tiefenprofil zu verschiedenen Zeiten
plt.plot(soil_m[1:,0,0],profil,'k-',label='start')
plt.plot(soil_m[1:,1,0],profil,label='1_d')
plt.plot(soil_m[1:,2,0],profil,label='2_d')
plt.plot(soil_m[1:,3,0],profil,label='3_d')
plt.plot(soil_m[1:,5,0],profil,label='5_d')
plt.plot(soil_m[1:,7,0],profil,label='7_d')
plt.plot(soil_m[1:,10,0],profil,label='10_d')
plt.plot(soil_m[1:,15,0],profil,label='15_d')
plt.plot(soil_m[1:,20,0],profil,label='20_d')
plt.plot(soil_m[1:,30,0],profil,label='30_d')
plt.plot(soil_m[1:,50,0],profil, 'b-',label='50_d')
plt.plot(soil_m[1:,75,0],profil,label='75_d')
plt.plot(soil_m[1:,100,0],profil,label='100_d')
plt.plot(soil_m[1:,150,0],profil,label='150_d')
plt.plot(soil_m[1:,200,0],profil,'k-',label='200_d')
plt.legend()
plt.show()


##Plot W in unterschiedlichen Tiefen ueber die Zeit
plt.plot(soil_m[1,:,0], label='5_cm')
plt.plot(soil_m[10/h,:,0], label='10_cm')
plt.plot(soil_m[20/h,:,0], label='20_cm')
plt.plot(soil_m[30/h,:,0], label='30_cm')
plt.plot(soil_m[50/h,:,0], label='50_cm')
plt.plot(soil_m[70/h,:,0], label='70_cm')
plt.plot(soil_m[80/h,:,0], label='80_cm')
plt.plot(soil_m[90/h,:,0], label='90_cm')
plt.plot(soil_m[95/h,:,0], label='95_cm')
plt.legend()
plt.show()