# -*- coding: utf-8 -*-
"""
Created on Wed Feb 15 09:19:02 2012 @author: tengen
Atmosphaere: N, O, D -Input, Verdunstung
"""

from numpy import *
from os import chdir as chdir

print 'start module atm_in'

###in N Verd isotope

end_mon_tag=zeros((12,2),int)
end_mon_tag[0,0],end_mon_tag[0,1]=1,31
end_mon_tag[1,0],end_mon_tag[1,1]=2,28
end_mon_tag[2,0],end_mon_tag[2,1]=3,31
end_mon_tag[3,0],end_mon_tag[3,1]=4,30
end_mon_tag[4,0],end_mon_tag[4,1]=5,31
end_mon_tag[5,0],end_mon_tag[5,1]=6,30
end_mon_tag[6,0],end_mon_tag[6,1]=7,31
end_mon_tag[7,0],end_mon_tag[7,1]=8,31
end_mon_tag[8,0],end_mon_tag[8,1]=9,30
end_mon_tag[9,0],end_mon_tag[9,1]=10,31
end_mon_tag[10,0],end_mon_tag[10,1]=11,30
end_mon_tag[11,0],end_mon_tag[11,1]=12,31

##Verdunstung
def dr(J):
    return 1.+0.033*cos(2*pi*J/365.)

def dec(J):
    return 0.4093*sin(2.*pi*J/365.-1.405)

def ws(lat,dec):
    return arccos(-tan(lat)*tan(dec))

def S(dr,ws,lat,dec):
    return 15.392*dr*(ws*sin(lat)*sin(dec)+cos(lat)*cos(dec)*sin(ws))

def etp(S,dT,T):
    return 0.0023*S*dT**0.5*(T+17.8)


################################################################################
################################################################################
##Inputfiles / Daten:
#Pfad
path='c:\HydroPro\Py\enable\modul_atm_in'
chdir(path)
#Temperatur (Verdunstung)
wilhelm_temp='Grad_Temp_max_min_mean.txt'
#Hoehe Station St.Wilhelm
elev_wilhelm_station=783
#Niederschlag + Isotope (Freiburg)
in_n_18o='Dat_O18_P_Freiburg_2011.txt'
#Hoehe Standort Profil
elev=250
#Latitude
lat=47.6
#Probenahmedatum (Tag, Monat, Jahr)
sample_date=[16,8,2009]
################################################################################
################################################################################

##monatliche Verdunstung
#Temperatur St. Wilhelm
w_t=loadtxt(wilhelm_temp)
#Temperatur Standort (trockenadiabiatisch)
ort_t=(elev_wilhelm_station-elev)/100*0.98+w_t
ort_t[:,0]=w_t[:,0]

lat=lat*pi/180.
 
##Input isotope + niederschlag
in_dat_p=loadtxt(in_n_18o)     ##Jahr, Monat, O, N, alpha
in_month=size(in_dat_p[:,0])   ##Anzahl Monate (Datenreihe) 
soil_w_monat=in_dat_p[:,3]*in_dat_p[:,4]        ## N*Infiltrationsfaktor alpha
mittel_in=sum((in_dat_p[:,2]*soil_w_monat))/sum(soil_w_monat)   ##gewichteter Mittelwert 


class atm_input(object):
    ##Bestimmung und zusammenfuegen der atmosph. Daten
    ##Isotope, Niederschlag,Infiltartionsanteil,Verdunstung        
    def atm_in(self,sample_date):    
        if (sample_date[1] > in_dat_p[in_month-1,1] and sample_date[2] >= in_dat_p[in_month-1,0]) or sample_date[2] > in_dat_p[in_month-1,0]:
            print 'ES LIEGEN NOCH KEINE NIEDERSCHLAGS UND ISOTOPENDATEN FUER DIE KOMPLETTE ZEITREIHE VOR'
            ##Anzahl fehlender Monate
            miss_month=(sample_date[2]-in_dat_p[in_month-1,0])*12+sample_date[1]-in_dat_p[in_month-1,1]
            print miss_month, 'MONATE FEHLEN'
            akt_line=in_month
            verd_monat=in_dat_p[in_month-1,1]-1
        else:
            #Zeile des angegebenen Datums / Monatsweise
            akt_line=where((in_dat_p[:,0]==sample_date[2]) & (in_dat_p[:,1]==sample_date[1]))[0][0]+1
            verd_monat=sample_date[1]
            miss_month=0
            #aktuellen Monat einbeziehen oder nicht        
            if sample_date[0] < 15:
                akt_line=akt_line-1
                verd_monat=sample_date[1]-1        
        in_daten=zeros((akt_line,4),float)  
        in_daten[:,0:3]=in_dat_p[0:akt_line,2:5]        ##Matrixende: aktueller Monat
    
        return in_daten, verd_monat

    def mon_pot_ver(self,lat):
        pot_mon_verd=zeros(12,float)
        sum_day_verd,Ju=0,0
        for j in range(0,12):
            for v in range(1,end_mon_tag[j,1]+1):
                Ju=Ju+1
                sum_day_verd=sum_day_verd+etp(S(dr(Ju),ws(lat,dec(Ju)),lat,dec(Ju)),ort_t[j,1]-ort_t[j,2],ort_t[j,3])
            pot_mon_verd[j]=sum_day_verd
            sum_day_verd=0
        return pot_mon_verd
    
    def in_all(self,sample_date,lat):
        ##Isotopen und Niederschlagsreihe und Monat fuer die Verdunstung
        in_daten_begin=atm_input.atm_in(self,sample_date)
        in_daten, verd_monat = in_daten_begin[0], in_daten_begin[1]-1
        #Verdunstungswerte hinzufuegen
        for m in range (0,12):  #verd_monat,verd_monat-12,-1)  
#            print atm_input.mon_pot_ver(self,lat)[9]
            in_daten[size(in_daten[:,0])-1-(m):0:-12,3]=atm_input.mon_pot_ver(self,lat)[verd_monat]
            verd_monat=verd_monat-1
            if verd_monat < 0:
                verd_monat=11
        return in_daten
        ##--> in_daten: Isotope, Niederschlag, Infiltartionsfaktor nach Malo, Verdunstung nach Hargreaves
        ##    MONATLICHE WERTE 
    
    pass

#a=atm_input()
#print a.in_all(sample_date,lat)



print 'end module atm_in'
