# -*- coding: utf-8 -*-
"""
Created on Wed Feb 20 16:19:02 2012 @author: tengen
Boden: vangenuchten parameter um ungesaetigte leitfaehigkeit zu bestimmen
"""
from numpy import *
from os import chdir as chdir

#from scipy import optimize as optimize

path='C:\HydroPro\Py\enable\modul_atm_in'
chdir(path)

genuchten_parameter='genuchten_parameter.txt'

input=open(genuchten_parameter,'r')
parameter=(input.readlines())
input.close

genu_para=zeros((size(parameter),6),float)
genu_soil=['']*size(parameter)


for i in range (0,size(parameter)):
    b=parameter[i].split('\t')    
    genu_para[i,0:6]=b[1:7]
    genu_soil[i]=str(b[0])

#Bodenparameter fuer angegebene Bodenart
def soil_genu_parameter(soil,genu_soil,genu_para):
    i=0
    while genu_soil[i] != soil:
        i=i+1        
    return genu_para[i,:]

#Bestimmung des Poetntials mit Parametern und Wassergehalt
def potential(soil,genu_soil,genu_para,water_content):
    para=soil_genu_parameter(soil,genu_soil,genu_para)
    Qr,Qs,l,n=para[0],para[1],para[2],para[3]
    
    sat_index=where(water_content >= Qs)   
    water_content[sat_index]=Qs
    
    m=1-1/n
    pot=-((((Qs-Qr)/(water_content-Qr))**(1/m)-1)**(1/n))/l

    return pot

#Bestimmung des Poetntials mit Parametern und Wassergehalt
def theta(soil,genu_soil,genu_para,pot):
    para=soil_genu_parameter(soil,genu_soil,genu_para)
    Qr,Qs,l,n=para[0],para[1],para[2],para[3]
    
#    sat_index=where(pot >= 0)
#    pot[sat_index]=0
    
    m=1-1/n
    
    theta=Qr+(Qs-Qr)/((1+(-l*pot)**n)**m)

    return theta

#Bestimmung der Leitfaehigkeit mit Parametern und Potential
#def unsat_k_pot(soil,genu_soil,genu_para,water_content):
def unsat_k_pot(soil,genu_soil,genu_para,Pot):
    para=soil_genu_parameter(soil,genu_soil,genu_para)
    Qr,Qs,l,n,x,K0=para[0],para[1],para[2],para[3],para[4],para[5]
    
    m=1-1/n
    
    k_unsat=K0*(1-(-l*Pot)**(n-1)*(1+(-l*Pot)**n)**(-m))**2/(1+(-l*Pot)**n)**(m*x)

    return k_unsat
    
#Bestimmung der Leitfaehigkeit mit Parametern und Potential
def diff_unsat_k_pot(soil,genu_soil,genu_para,water_content):
    para=soil_genu_parameter(soil,genu_soil,genu_para)
    Qr,Qs,l,n,x,K0=para[0],para[1],para[2],para[3],para[4],para[5]
    
    sat_index=where(water_content >= Qs)
    
    if size(sat_index[:]) == size(water_content):
        water_content[:]=0
        return water_content
    
    m=1-1/n
    Po=potential(soil,genu_soil,genu_para,water_content)
       
    part1=2*K0*(1-(-l*Po)**(n-1)*(1+(-l*Po)**n)**(-m))
    part2= (-(-l*Po)**(n-1)*(n-1)*(1+(-l*Po)**n)**m/Po-(-l*Po)**(n-1)*(1+(-l*Po)**n)**m*(1-n)*(-l*Po)**n/(Po*(1+(-l*Po)**n)))
    part3=(1+(-l*Po)**n)**((n-1)/2*n)
    part4= -0.5*K0*(1-(-l*Po)**(n-1)*(1+(-l*Po)**n)**m)**2*(n-1)*(-l*Po)**n/((1+(-l*Po)**n)**((n-1)/2*n)*Po*(1+(-l*Po)**n))
    
    diff_k=part1*part2/part3-part4
    
    if size(sat_index[:]) >0:
        diff_k[sat_index]=0 
    
    return diff_k

#def diff_potential(soil,genu_soil,genu_para,water_content,h):
#    
#def diff_2_potential(soil,genu_soil,genu_para,water_content,h):
    

#Bestimmung der Leitfaehigkeit mit Parametern und Wassergehalt  - nicht im Gebrauch
def unsat_k_wasser(soil,genu_soil,genu_para,water_content):
    para=soil_genu_parameter(soil,genu_soil,genu_para)
    Qr,Qs,n,x,K0=para[0],para[1],para[3],para[4],para[5]
    m=1-1/n
    S=(water_content-Qr)/(Qs-Qr)
    return K0*S**x*(1-(1-S**(1/m))**m)**2


