# -*- coding: utf-8 -*-

from numpy import size as size

#def konz_delta_O18(d_O18):
#    d_O=0.0020052
#    d_O18=d_O18/1000.
#    R_18O=d_O*(d_O18+1)    
#    c_18O=R_18O/(R_18O+1)
#    return c_18O
#    
#def konz_delta_H2(d_H2):
#    d_H=0.00015576
#    d_H2=d_H2/1000.
#    R_2H=d_H*(d_H2+1)
#    c_2H=R_2H/(R_2H+1)    
#    return c_2H

#def delta_konz_H2(c_H2):
#    d_H=0.00015576
#    R_2H=c_H2/(1-c_H2)
#    d_H2=R_2H/d_H-1
#  
#    return d_H2*1000.
    
def konz_delta(d_O18,d_H2):
    if size(d_H2)==1:
        if d_H2==0:
            d_H2=8*d_O18+10
    if size(d_O18)==1:
        if d_O18==0:
            d_O18=(d_H2-10)/8
    d_O, d_H = 0.0020052 , 0.00015576
    d_O18, d_H2 = d_O18/1000.,d_H2/1000.
    a_u=1.66053892173e-27   #atomic unit (kg)

    R_O=d_O*(d_O18+1)
    R_H=d_H*(d_H2+1)

    N16O=(R_H+1)/(a_u*(22*R_O*R_H+20*R_O+20*R_H+18))
    N18O=N16O*R_O
    c_18O=N18O*18.*a_u
    
    N1H=2*(N18O+N16O)/(R_H+1)
    N2H=N1H*R_H
    c_2H=N2H*2*a_u

    return c_18O, c_2H

def delta_konz(c_O18,c_H2):
    d_O, d_H = 0.0020052 , 0.00015576
    a_u=1.66053892173e-27   #atomic unit (kg)
    N18O=c_O18/(18*a_u)
    N2H=c_H2/(2*a_u)
    
    N16O=((1/a_u-(2*N18O+N2H))/18)-N18O
    N1H=2*(N16O+N18O)-N2H
    
    R_O=N18O/N16O
    R_H=N2H/N1H
    
    d_O18=1000.*(R_O-d_O)/d_O    
    d_H2=1000.*(R_H-d_H)/d_H
    return d_O18, d_H2

